--  checkbox.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include panel.e

constant
    d = 13,     -- box size
    tick = {
        repeat(repeat(11,9),7),         -- blank
        {
        {11,11,11,11,11,11,11,11,00},   -- check
        {11,11,11,11,11,11,11,00,00},
        {11,11,11,11,11,11,00,00,11},
        {00,00,11,11,11,00,00,11,11},
        {11,00,00,11,00,00,11,11,11},
        {11,11,00,00,00,11,11,11,11},
        {11,11,11,00,11,11,11,11,11}}}

integer m1,m2,m3

global function checkbox(
    sequence label,     -- text string
    integer x,          -- left edge
    integer y,          -- top edge
    integer state       -- state: 1 if checked, else 0
    )
    sequence lens
    integer k,wi,w,wp,wt

    wid = append(wid, {{"state","show","rat","kbd","event","key"},
        {state,m1,{m2},{m3},lbp+kbd_event,{}}})
    wi = length(wid)
    k = find('~',label)
    if k then bind(wi, "key", {label[k+1]}) end if

    wp = panel(11,edge[2],x,y,d,d)
    affix(wi, "panel", wp)

    wt = text(x+20, y+7, label)
    bind(wt, "just", LEFT+BOXED)
    affix(wi, "label", wt)

    -- determine total width of widget, including label
    retext(wt)
    lens = lengths(label)
    w = 20 + max(lengths(label))
    make(wi, "box", {x,y,w,d})        -- tracked box

    return wi
end function -- checkbox

global procedure show_checkbox(integer wi)
    sequence s
    integer state,x,y

    show_panel(part(wi, "panel"))
    state = item(wi, "state")
    if state then
        s = item(wi, "box")
        x = s[1] + 2
        y = s[2] + 3
        hide_rat()
        put_image(x, y, tick[2])
    end if
    show_text(part(wi, "label"))
end procedure
m1 = routine_id("show_checkbox")

procedure toggle_checkbox()
    sequence s
    integer state,x,y

    s = item(self,"box")
    state = not item(self, "state")
    x = s[1] + 2
    y = s[2] + 3
    hide_rat()
    put_image(x, y, tick[state+1])
    show_rat()
    bind(self, "state", state)
end procedure -- toggle_checkbox
m3 = routine_id("toggle_checkbox")

procedure on_rat_checkbox()
    toggle_checkbox()
    wait_while(lbp)
end procedure
m2 = routine_id("on_rat_checkbox")
