--  isel.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include pbutton.e

constant
    larrow = {
        {1,1,1,0},
        {1,1,0,0},
        {1,0,0,0},
        {0,0,0,0},
        {1,0,0,0},
        {1,1,0,0},
        {1,1,1,0}},
    rarrow = {
        {0,1,1,1},
        {0,0,1,1},
        {0,0,0,1},
        {0,0,0,0},
        {0,0,0,1},
        {0,0,1,1},
        {0,1,1,1}}

integer m1,m2,m3

global function isel(
    sequence label,
    integer xl,         -- label left edge
    integer n,          -- starting (default) value
    integer min,        -- minimum value
    integer max,        -- maximum value
    integer x,          -- box left edge
    integer y,          -- box top edge
    integer w,          -- box width, total
    integer h           -- box height
    )
    integer v,wi,w0,w1,w2,w3,w4

    wid = append(wid, {{"max","min","selected","show"},{max,min,n,m1}})
    wi = length(wid)

    w0 = panel(8, edge[2], x, y, w-16, h)
    affix(wi, "panel", w0)

    v = floor((h+1)/2)          -- vertical offset
    w3 = text(xl, y+v+1, label)
    bind(w3, "just", LEFT+BOXED)
    affix(wi, "label", w3)

    w4 = text(x+w-20, y+v+1, sprint(n))
    bind(w4, "just", RIGHT+BOXED)
    affix(wi, "digits", w4)

    w1 = pbutton(x+w-16,y,8,h,larrow,2,v-4,1)    -- left arrow button
    bind(w1, "key", {331})
    splice(w1, m3)
    affix(wi, "lar", w1)

    w2 = pbutton(x+w-8,y,8,h,rarrow,2,v-4,1)      -- right arrow button
    bind(w2, "key", {333})
    splice(w2, m2)
    affix(wi, "rar", w2)

    return wi
end function -- isel

global procedure show_isel(integer wi)
    show_panel(part(wi, "panel"))
    show_pbutton(part(wi, "lar"))
    show_pbutton(part(wi, "rar"))
    show_text(part(wi, "label"))
    show_text(part(wi, "digits"))
end procedure -- show_isel
m1 = routine_id("show_isel")

procedure on_rarrow()
    integer n,wm,wt,max,x,y

    wm = main(self)                 -- isel widget
    n = item(wm, "selected")
    max = item(wm, "max")
    if n < max then
        n += 1
        bind(wm, "selected", n)
        wt = part(wm, "digits")     -- text widget
        retext(wt)
        x = item(wt, "x")
        y = item(wt, "y")
        setxy(x,y)
        show_panel(part(wm, "panel"))
        hide_rat()
        write(sprint(n))
        show_rat()
    end if
end procedure -- on_rarrow
m2 = routine_id("on_rarrow")

procedure on_larrow()
    integer n,wm,wt,min,x,y

    wm = main(self)                 -- isel widget
    n = item(wm, "selected")
    min = item(wm, "min")
    if n > min then
        n -= 1
        bind(wm, "selected", n)
        wt = part(wm, "digits")     -- text widget
        retext(wt)
        x = item(wt, "x")
        y = item(wt, "y")
        setxy(x,y)
        show_panel(part(wm, "panel"))
        hide_rat()
        write(sprint(n))
        show_rat()
    end if
end procedure -- on_larrow
m3 = routine_id("on_larrow")
