--  listbox.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include vscroll.e

constant pgup = 329
constant pgdn = 337
integer m1,m2,m3,m4,m5,m6

global function listbox(
    sequence lines,     -- sequence of strings
    integer x,          -- box left edge
    integer y,          -- box top edge
    integer w,          -- total box width, including scroller
    integer h           -- box height
    )
    sequence s1
    integer h1,h2,len,n,wi,w0,w1,w2,w3,w4,w5,wt

    wid = append(wid, {{"event","first","kbd","key","lines","pitch","selected","show"},
        {kbd_event,1,{m6},{pgup, pgdn},lines,15,{},m1}})
    wi = length(wid)

    wt = text(x+4, y+2, "")         -- text widget
    affix(wi, "text", wt)

    w1 = vscroll(x+w-11,y,h)

    w2 = part(w1, "bed")            -- slider bed
    arat(w2, m3)

    w3 = part(w1, "uar")            -- up arrow
    splice(w3, m4)

    w4 = part(w1, "dar")            -- down arrow
    splice(w4, m5)

    n = floor((h-4)/15)
    len = length(lines)
    if n<len then
        w -= 11
        w5 = part(w1, "slider")     -- slider
        s1 = item(w5, "box")        -- slider panel
        h2 = h - 22                 -- length of slide (bed)
        h1 = round((n*h2)/len)
        if h1<5 then h1 = 5 end if
        s1[4] = h1
        bind(w5, "box", s1)
    end if
    w0 = panel(8,edge[2],x,y,w,h)   -- listbox box
    make(w0, "event", lbp)
    make(w0, "rat", {m2})
    affix(wi, "panel", w0)
    affix(wi, "vsc", w1)            -- vscroll must be added AFTER panel!
    return wi
end function -- listbox

procedure show_lines(integer wi     -- listbox
    )
    sequence lines, box,selected
    integer first,last,len,n,pitch,w,w1,wt,x,y

    lines = item(wi, "lines")
    first = item(wi, "first")
    selected = item(wi, "selected")
    pitch = item(wi, "pitch")
    w1 = part(wi, "panel")          -- listbox box
    box = item(w1, "box")
    wt = part(wi, "text")
    x = box[1]+4
    y = box[2]+2
    w = box[3]-4
    len = length(lines)
    n = floor((box[4]-4)/pitch)     -- max number of lines shown
    if len then
        show_panel(w1)
        if len>n then
            last = first+n-1
        else
            last = len
        end if
        retext(wt)
        hide_rat()
        for i = first to last do
            setxy(x,y)
            if find(i, selected) then
                bar(3, x-2, y, w, pitch)
                set_foreground(15)
            else
                set_foreground(0)
            end if
            write(lines[i])
            y += pitch
        end for
        show_rat()
    end if
end procedure -- show_lines

global procedure show_listbox(integer wi    -- listbox
    )
    sequence s,lines
    integer n,pitch,w1,w2

    w1 = part(wi, "panel")          -- listbox box
    w2 = part(wi, "vsc")
    s = item(w1, "box")
    pitch = item(wi, "pitch")
    lines = item(wi, "lines")
    n = floor((s[4]-4)/pitch)       -- max number of lines shown
    show_lines(wi)
    if n < length(lines) then
        show_vscroll(w2)
    end if
end procedure -- show_listbox
m1 = routine_id("show_listbox")

procedure on_rat_listbox()
    sequence lines,s,selected
    integer first,k,m,n,dy,len,pitch,wm,wt,x,y

    wm = main(self)                 -- listbox
    wt = part(wm, "text")
    retext(wt)
    pitch = item(wm, "pitch")
    s = item(self,"box")            -- listbox box
    x = s[1]
    y = s[2]
    lines = item(wm,"lines")
    first = item(wm,"first")
    selected = item(wm,"selected")
    m = floor((s[4]-4)/pitch)       -- max number of shown lines
    dy = ry-y-2
    n = floor(dy/pitch)
    if n>=0 and n<m then
        n += first
        len = length(lines)
        if n <= len then
            hide_rat()
            k = find(n, selected)
            if k then
                bar(8,x+2,y+(n-first)*pitch+2,s[3]-4,pitch)
                set_foreground(0)
                setxy(x+4,y+(n-first)*pitch+2)
                write(lines[n])
                selected = selected[1..k-1] & selected[k+1..length(selected)]    -- delete
            else
                bar(3,x+2,y+(n-first)*pitch+2,s[3]-4,pitch)
                set_foreground(15)
                setxy(x+4,y+(n-first)*pitch+2)
                write(lines[n])
                selected &= n
            end if
            show_rat()
            bind(wm, "selected", selected)
            wait_while(lbp)
        end if
    end if
end procedure -- on_rat_listbox
m2 = routine_id("on_rat_listbox")

procedure on_rat_bed()
    sequence box,lines,s1,s2
    atom pos
    integer first,h,h1,h2,l,n,pitch,wm,ws,wi,w1

    ws = main(self)                 -- vscroll
    w1 = part(ws, "slider")
    s1 = item(w1, "box")
    s2 = item(self, "box")          -- slide (bed)
    h1 = s1[4]                      -- slider length (height)
    h2 = s2[4]                      -- bed length (height)
    if h1 < h2 then
        wm = main(ws)               -- listbox
        pitch = item(wm, "pitch")
        wi = part(wm, "panel")      -- listbox box
        box = item(wi, "box")
        h = box[4]                  -- listbox height
        n = floor((h-4)/pitch)      -- max number of lines shown
        lines = item(wm, "lines")
        l = length(lines)
        pos = (s1[2]-s2[2])/(h2-h1)
        first = floor((l-n)*pos)+1
        make(wm, "f", first)
        show_lines(wm)
    end if
end procedure -- on_rat_bed
m3 = routine_id("on_rat_bed")

procedure on_rat_uarrow()
    sequence box,lines,s1,s2
    atom pos
    integer first,h,l,n,pitch,wi,wm,w1,w2,w3

    wm = main(self)                 -- vscroll
    wi = main(wm)                   -- listbox
    first = item(wi, "first")
    pitch = item(wi, "pitch")
    if first > 1 then
        first -= 1
        make(wi, "first", first)
        w1 = part(wm, "slider")
        w2 = part(wm, "bed")
        w3 = part(wi, "panel")        -- listbox box
        show_lines(wi)
        box = item(w3, "box")
        s1 = item(w1, "box")
        s2 = item(w2, "box")
        h = box[4]                  -- listbox height
        n = floor((h-4)/pitch)      -- max number of lines shown
        lines = item(wi, "lines")
        l = length(lines)
        pos = (first-1)/(l-n)
        s1[2] = s2[2] + round(pos * (s2[4]-s1[4]))
        make(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    end if
end procedure
m4 = routine_id("on_rat_uarrow")

procedure on_rat_darrow()
    sequence box,lines,s1,s2
    atom pos
    integer first,h,l,n,pitch,wi,wm,w1,w2,w3

    wm = main(self)                 -- vscroll
    wi = main(wm)                   -- listbox
    w3 = part(wi, "panel")            -- listbox box
    first = item(wi, "first")
    pitch = item(wi, "pitch")
    box = item(w3, "box")
    h = box[4]                      -- listbox height
    n = floor((h-4)/pitch)          -- max number of lines shown
    lines = item(wi, "lines")
    l = length(lines)
    if first+n-1 < l then
        first += 1
        make(wi, "first", first)
        show_lines(wi)
        w1 = part(wm, "slider")
        w2 = part(wm, "bed")
        s1 = item(w1, "box")
        s2 = item(w2, "box")
        pos = (first-1)/(l-n)
        s1[2] = s2[2] + round(pos * (s2[4]-s1[4]))
        make(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    end if
end procedure
m5 = routine_id("on_rat_darrow")

procedure on_page()
    sequence lines,s,s1,s2
    integer f,l,n,p,wb,ws,w1,w2

    wb = part(self, "panel")        -- linebox
    ws = part(self, "vsc")          -- vscroll
    w1 = part(ws, "slider")
    s1 = item(w1, "box")
    w2 = part(ws, "bed")            -- chequered bed
    s2 = item(w2, "box")
    s = item(wb, "box")
    p = item(self, "pitch")         -- line pitch
    lines = item(self, "lines")
    l = length(lines)
    f = item(self, "first")         -- first line number
    n = floor((s[4]-4)/p)           -- max number of displayable lines
    if pressed_key = pgdn and f+n <= l then
        f = f+n
        if f+n-1 > l then f = l-n +1 end if
        bind(self, "first", f)
        show_lines(self)
        s1[2] = s2[2] + round((f-1)*(s2[4]-s1[4])/(l-n))
        bind(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    elsif pressed_key = pgup and f > 1 then
        f = f-n
        if f < 1 then f = 1 end if
        bind(self, "first", f)
        show_lines(self)
        s1[2] = s2[2] + round((f-1)*(s2[4]-s1[4])/(l-n))
        bind(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    end if
end procedure -- on_page
m6 = routine_id("on_page")
