--  mbox.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include button.e
include window.e

integer m1,m2

global function mbox(
    sequence title,     -- text string
    sequence message,   -- text
    sequence labels,    -- zero, or more button labels in a sequence
    integer x,          -- left edge
    integer y,          -- top edge
    integer w,          -- width
    integer h           -- height
    )
    integer n,wi,wb,wt,yt

    wi = window(title,x,y,w,h)
    make(wi, "selected", 0)
    wt = text(x+floor((w+1)/2), y+floor((h+1)/2), message)
    bind(wt, "just", CENTRE+BOXED)
    affix(wi, "text", wt)
    n = length(labels)              -- number of buttons
    if n then
        yt = y-1+floor(h/2)
    else
        yt = y+8+floor(h/2)
    end if
    bind(wi, "show", m1)
    if n then                       -- one or more buttons
        x += floor((w-n*75+5)/2)
        y += h-23
        for i=1 to n do
            wb = button(labels[i], x, y, 70, 19)
            splice(wb, m2)
            affix(wi, labels[i], wb)
            x += 75
        end for
    end if
    return wi
end function -- mbox

global procedure show_mbox(integer wi)
    object s

    show_window(wi)
    show_text(part(wi, "text"))

    s = item(wi, "parts")           -- component list
    s = s[2]                        -- component sequence (buttons)
    show(s)                         -- show buttons
end procedure -- show_mbox
m1 = routine_id("show_mbox")

procedure on_mbox_button()
    integer wm

    wm = main(self)
    bind(wm, "selected", self)
    hide_window(wm)
end procedure
m2 = routine_id("on_mbox_button")
