--  rbutton.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include widgets.e

constant
    RB = {{
    {07,07,07,07,03,03,03,03,03,07,07,07,07},
    {07,07,03,03,15,15,15,15,15,15,03,07,07},
    {07,03,15,15,15,15,15,15,15,15,15,03,07},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {03,15,15,15,15,15,15,15,15,15,15,15,08},
    {03,15,15,15,15,15,15,15,15,15,15,15,08},
    {03,15,15,15,15,15,15,15,15,15,15,15,08},
    {03,15,15,15,15,15,15,15,15,15,15,15,08},
    {03,15,15,15,15,15,15,15,15,15,15,15,08},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {07,07,08,15,15,15,15,15,15,15,08,07,07},
    {07,07,07,07,08,08,08,08,08,07,07,07,07}},
    {
    {07,07,07,07,03,03,03,03,03,07,07,07,07},
    {07,07,03,03,15,15,15,15,15,15,03,07,07},
    {07,03,15,15,15,15,15,15,15,15,15,03,07},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {03,15,15,15,15,00,00,00,15,15,15,15,08},
    {03,15,15,15,00,00,00,00,00,15,15,15,08},
    {03,15,15,15,00,00,00,00,00,15,15,15,08},
    {03,15,15,15,00,00,00,00,00,15,15,15,08},
    {03,15,15,15,15,00,00,00,15,15,15,15,08},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {07,03,15,15,15,15,15,15,15,15,15,08,07},
    {07,07,08,15,15,15,15,15,15,15,08,07,07},
    {07,07,07,07,08,08,08,08,08,07,07,07,07}}}

integer m1,m2,m3

global function rbutton(
    sequence label,     -- text string
    integer x,          -- left edge
    integer y,          -- top edge
    integer state       -- bool: 1 if selected, else 0
    )
    integer k,wi,w,wt
    sequence lens

    wid = append(wid, {{"event", "kbd", "key", "rat", "state", "show"},
        {lbp+kbd_event, {m3}, {}, {m2}, state, m1}})
    wi = length(wid)
    k = find('~',label)
    if k then make(wi, "key", {label[k+1]}) end if

    wt = text(x+20, y+7, label)
    bind(wt, "just", LEFT+BOXED)
    affix(wi, "label", wt)

    -- determine total width of widget, including label
    retext(wt)
    lens = lengths(label)
    w = 20 + max(lengths(label))
    make(wi, "box", {x,y,w,13})        -- tracked box

    return wi
end function -- rbutton

global procedure show_rbutton(integer wi)
    sequence s
    integer state,x,y

    s = item(wi, "box")
    state = item(wi, "state")
    x = s[1]
    y = s[2]
    hide_rat()
    put_image(x,y,RB[state+1])
    show_text(part(wi, "label"))
end procedure -- show_rbutton
m1 = routine_id("show_rbutton")

procedure toggle_rbutton()
    sequence s
    integer state,wm,wo

    state = item(self, "state")
    wm = main(self)
    if state = 0 or wm = 0 then
        state = not state
        s = item(self,"box")
        bind(self, "state", state)
        hide_rat()
        put_image(s[1],s[2],RB[state+1])
        if wm then
            wo = item(wm, "selected")       -- previously selected rbutton
            s = item(wo, "box")
            bind(wo, "state", 0)            -- deselect
            put_image(s[1], s[2], RB[1])    -- blank
            bind(wm, "selected", self)      -- currently selected rbutton
        end if
        show_rat()
    end if
end procedure -- toggle_rbutton
m3 = routine_id("toggle_rbutton")

procedure on_rat_rbutton()
    toggle_rbutton()
    wait_while(lbp)
end procedure -- on_rat_rbutton
m2 = routine_id("on_rat_rbutton")
