--  reader.e : window widget for display of scrollable text
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include window.e
include vscroll.e

include cognac10.e              -- font

constant pgup = 329
constant pgdn = 337
constant p = 14                 -- line pitch
integer m1,m2,m3,m4,m5

global function reader(
    sequence title,
    sequence lines,
    integer x,
    integer y,
    integer w,
    integer h
    )
    sequence s
    integer l,n,wi,w1,w1u,w1d,w1b,w2,w3,w4

    wi = window(title,x,y,w,h)
    bind(wi, "show", m1)
    make(wi, "lines", lines)
    make(wi, "pitch", p)
    make(wi, "kbd", {m5})
    make(wi, "event", kbd_event)
    make(wi, "key", {pgup, pgdn})   -- page up, page down keys

    w1 = vscroll(x+w-16,y+22,h-27)
    w1u = part(w1, "uar")           -- up arrow
    splice(w1u, m2)
    w1d = part(w1, "dar")           -- down arrow
    splice(w1d, m3)
    w1b = part(w1, "bed")           -- chequered slide
    arat(w1b, m4)
    affix(wi, "vsc", w1)

    w2 = text(x+10,y+25,"")         -- text widget
    bind(w2, "font", cognac10)
    affix(wi, "text", w2)
    make(wi, "first", 1)            -- first line, default
    n = floor((h-31)/p)             -- max number of displayable lines
    l = length(lines)
    if n < l then
        w3 = panel(8,edge[2],x+5,y+22,w-21,h-27)
        w4 = part(w1, "slider")     -- slider
        s = item(w4, "box")
        s[4] = round((h-49)*n/l)    -- length of slider
        bind(w4, "box", s)
    else
        w3 = panel(8,edge[2],x+5,y+22,w-10,h-27)
    end if
    affix(wi, "lbox", w3)
    return wi
end function -- reader

global procedure show_reader(integer wi)
    sequence lines,s
    integer first,i,l,n,p,w1,w2,x,y

    show_window(wi)
    w1 = part(wi, "lbox")
    w2 = part(wi, "text")
    show_panel(w1)
    s = item(w1, "box")
    x = s[1] + 5
    y = s[2] + 2
    lines = item(wi, "lines")
    p = item(wi, "pitch")
    first = item(wi, "first")
    n = floor((s[4]-4)/p)          -- max number of displayable lines
    l = length(lines)
    if n < l then
        show_vscroll(part(wi, "vsc"))
    end if

    -- show lines
    retext(w2)
    i = first
    hide_rat()
    while (i <= l)  and (i-first < n) do
        setxy(x,y)
        write(lines[i])
        i += 1
        y += p
    end while
    show_rat()
end procedure -- show_reader
m1 = routine_id("show_reader")

procedure show_lines(integer wi     -- reader
    )
    sequence lines,s
    integer first,i,l,n,p,w1,w2,x,y

    w1 = part(wi, "lbox")
    w2 = part(wi, "text")
    show_panel(w1)
    s = item(w1, "box")
    x = s[1] + 5
    y = s[2] + 2
    lines = item(wi, "lines")
    p = item(wi, "pitch")
    first = item(wi, "first")
    n = floor((s[4]-4)/p)          -- max number of displayable lines
    l = length(lines)

    retext(w2)
    i = first
    hide_rat()
    while (i <= l)  and (i-first < n) do
        setxy(x,y)
        write(lines[i])
        i += 1
        y += p
    end while
    show_rat()
end procedure -- show_lines

procedure on_uar()
    sequence lines,s,s1,s2
    integer first,l,n,p,wb,wm,ws,w1,w2,y1,y2

    ws = main(self)                 -- vscroll
    wm = main(ws)                   -- reader
    wb = part(wm, "lbox")           -- linebox
    p = item(wm, "pitch")           -- line pitch
    first = item(wm, "first")       -- first line
    s = item(wb, "box")
    n = floor((s[4]-4)/p)           -- max number of displayable lines
    if first > 1 then
        lines = item(wm, "lines")
        l = length(lines)
        first -= 1
        bind(wm, "first", first)
        show_lines(wm)
        w1 = part(ws, "bed")        -- chequered slide
        s1 = item(w1, "box")
        w2 = part(ws, "slider")     -- slider
        s2 = item(w2, "box")
        y1 = s1[2]
        y2 = y1+round((first-1)*(s1[4]-s2[4])/(l-n))
        s2[2] = y2
        bind(w2, "box", s2)
        show_pane(w1)
        show_panel(w2)
    end if
end procedure -- on_uar
m2 = routine_id("on_uar")

procedure on_dar()
    sequence lines,s,s1,s2
    integer first,l,n,p,wb,wm,ws,w1,w2,y1,y2

    ws = main(self)                 -- vscroll
    wm = main(ws)                   -- reader
    wb = part(wm, "lbox")           -- linebox
    p = item(wm, "pitch")           -- line pitch
    lines = item(wm, "lines")
    l = length(lines)
    first = item(wm, "first")
    s = item(wb, "box")
    n = floor((s[4]-4)/p)           -- max number of displayable lines
    if first+n-1 < l then
        lines = item(wm, "lines")
        first += 1
        bind(wm, "first", first)
        show_lines(wm)
        w1 = part(ws, "bed")        -- chequered slide
        s1 = item(w1, "box")
        w2 = part(ws, "slider")     -- slider
        s2 = item(w2, "box")
        y1 = s1[2]
        y2 = y1+round((first-1)*(s1[4]-s2[4])/(l-n))
        s2[2] = y2
        bind(w2, "box", s2)
        show_pane(w1)               -- bed
        show_panel(w2)              -- slider
    end if
end procedure -- on_dar
m3 = routine_id("on_dar")

procedure on_bed()
    sequence lines,s,s1,s2
    integer first,l,n,p,wb,ws,wm,w1

    ws = main(self)                 -- vscroll
    wm = main(ws)                   -- reader
    wb = part(wm, "lbox")           -- linebox
    w1 = part(ws, "slider")         -- slider
    s = item(wb, "box")
    s1 = item(w1, "box")
    s2 = item(self, "box")
    lines = item(wm, "lines")
    p = item(wm, "pitch")
    l = length(lines)
    n = floor((s[4]-4)/p)           -- max number of displayable lines
    first = 1 + round((l-n)*(s1[2]-s2[2])/(s2[4]-s1[4]))
    bind(wm, "first", first)
    show_lines(wm)
end procedure -- on_bed
m4 = routine_id("on_bed")

procedure on_page()
    sequence lines,s,s1,s2
    integer f,l,n,p,wb,ws,w1,w2

    wb = part(self, "lbox")         -- linebox
    ws = part(self, "vsc")          -- vscroll
    w1 = part(ws, "slider")         -- slider
    s1 = item(w1, "box")
    w2 = part(ws, "bed")            -- chequered bed
    s2 = item(w2, "box")
    s = item(wb, "box")
    p = item(self, "pitch")         -- line pitch
    lines = item(self, "lines")
    l = length(lines)
    f = item(self, "first")         -- first line number
    n = floor((s[4]-4)/p)           -- max number of displayable lines
    if pressed_key = pgdn and f+n-1 <= l then
        f = f+n-1
        if f+n-2 > l then f = l-n +2 end if
        bind(self, "first", f)
        show_lines(self)
        s1[2] = s2[2] + round((f-1)*(s2[4]-s1[4])/(l-n+1))
        bind(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    elsif pressed_key = pgup and f > 1 then
        f = f-n+1
        if f < 1 then f = 1 end if
        bind(self, "first", f)
        show_lines(self)
        s1[2] = s2[2] + round((f-1)*(s2[4]-s1[4])/(l-n+1))
        bind(w1, "box", s1)
        show_pane(w2)
        show_panel(w1)
    end if
end procedure -- on_page
m5 = routine_id("on_page")
