--  screen.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

without warning
without type_check

include pane.e
include pbutton.e

constant
    bh = 15,            -- default bar height
    bigx = {            -- closing gadget image
        {4,1,1,1,1,1,4},
        {4,4,1,1,1,4,4},
        {1,4,4,1,4,4,1},
        {1,1,4,4,4,1,1},
        {1,1,4,4,4,1,1},
        {1,4,4,1,4,4,1},
        {4,4,1,1,1,4,4},
        {4,1,1,1,1,1,4}}

integer m1,m2,sbar

function screen_bar(sequence title)
    integer wi,w1,w2

    wi = pane(8, 0, 0, hsize, bh)
    bind(wi, "show", m1)

    w1 = pbutton(hsize-14,1,13,13,bigx,3,2,1)
    bind(w1, "key", {esc})
    splice(w1, m2)
    affix(wi, "closer", w1)

    w2 = text(5, floor((bh+1)/2), title)
    bind(w2, "fc", 4)
    bind(w2, "sc", 7)
    bind(w2, "attrib", SHADOW)
    bind(w2, "just", LEFT+BOXED)
    affix(wi, "title", w2)

    return wi
end function -- screen_bar

procedure show_screen_bar(integer wi)
    show_pane(wi)
    show_pbutton(part(wi, "closer"))
    show_text(part(wi, "title"))
end procedure -- show_screen_bar
m1 = routine_id("show_screen_bar")

procedure on_closer()
    exitf = true
end procedure -- on_closer
m2 = routine_id("on_closer")

global procedure cls(           -- clear screen
    object bg                   -- background color or 2d pattern
    )
    hide_rat()
    bar(bg,0,0,hsize,vsize)
    show_screen_bar(main(screen))
end procedure

global procedure set_screen(
    sequence title,             -- screen title
    integer mode,               -- graphics mode
    object bground              -- background color or 2d pattern
    )
    integer w

    set_mode(mode)
    w = screen_bar(title)       -- screen index as flag
    screen = part(w, "closer")
    cls(bground)
end procedure -- set_screen
