--  sle.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include panel.e

integer m1, m2

global function sle(    -- single line edit
    sequence label,     -- text string
    integer xl,         -- label left edge
    sequence line,      -- initial text in box
    integer x,          -- left edge of box
    integer y,          -- top edge of box
    integer w,          -- box width (length)
    integer h           -- box height
    )
    integer k,wi,w1,w2

    wi = panel(8, edge[2], x, y, w, h)
    k = find('~',label)
    if k then
        make(wi, "key", {label[k+1]})
    else
        make(wi, "key", {})
    end if

    make(wi, "string", line)
    make(wi, "show", m1)
    make(wi, "rat", {m2})
    make(wi, "kbd", {m2})
    make(wi, "event", lbp+kbd_event)

    -- label:
    w1 = text(xl, y + floor((h+1)/2), label)
    bind(w1, "just", LEFT+BOXED)
    affix(wi, "label", w1)

    -- line:
    w2 = text(0, 0, "")     -- just dummy values, not used
    bind(w2, "paper", 11)
    affix(wi, "text", w2)

    return wi
end function -- sle

global procedure show_sle(integer wi)
    sequence line,s
    integer wt,x,y

    show_panel(wi)
    show_text(part(wi, "label"))

    wt = part(wi, "text")
    retext(wt)
    line = item(wi, "string")
    s = item(wi, "box")
    x = s[1] + 5
    y = s[2] + floor((s[4]-height()+1)/2)
    setxy(x, y)
    hide_rat()
    write_within(line, 1, s[3]-10)
    show_rat()
end procedure -- show_sle
m1 = routine_id("show_sle")

procedure on_event_sle()
    sequence line,o,s
    integer wt,x,y

    bind(self, "color", 11)
    show_panel(self)
    wt = part(self, "text")
    retext(wt)
    line = item(self, "string")
    s = item(self, "box")
    x = s[1] + 5
    y = s[2] + floor((s[4]-height()+1)/2)
    setxy(x, y)
    hide_rat()
    o = prompt(line, s[3]-10)
    show_rat()
    line = o[2]
    bind(self, "color", 8)
    bind(self, "string", line)
    show_sle(self)
end procedure -- on_event_sle
m2 = routine_id("on_event_sle")
