--  vscroll.e : vertical scroll
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

without warning
without type_check

include pane.e
include pbutton.e

constant
    XX = {{11,3},{3,11}},               -- slide background
    DARROW = {
        {0,0,0,0,0,0,0},
        {1,0,0,0,0,0,1},
        {1,1,0,0,0,1,1},
        {1,1,1,0,1,1,1}},
    UARROW = {
        {1,1,1,0,1,1,1},
        {1,1,0,0,0,1,1},
        {1,0,0,0,0,0,1},
        {0,0,0,0,0,0,0}}

integer m1,m2

global function vscroll(
    integer x,          -- left edge
    integer y,          -- top edge
    integer l           -- total length (height)
    )
    integer wi,w1,w2,w3,w4

    wid = append(wid, {{"show"},{m1}})
    wi = length(wid)

    w1 = pbutton(x,y,11,11,UARROW,2,3,1)        -- up arrow button
    bind(w1, "key", {328})
    affix(wi, "uar", w1)

    w2 = pbutton(x,y+11,11,11,DARROW,2,4,1)     -- down arrow button
    bind(w2, "key", {336})
    affix(wi, "dar", w2)

    w3 = pane(XX, x, y+22, 11, l-22)            -- chequered slide
    make(w3, "event", lbp)
    make(w3, "rat", {m2})
    affix(wi, "bed", w3)

    w4 = panel(7, edge[1], x, y+22, 11, 5)      -- slider
    affix(wi, "slider", w4)

    return wi
end function -- vscroll

global procedure show_vscroll(integer wi)
    show_pbutton(part(wi, "uar"))
    show_pbutton(part(wi, "dar"))
    show_pane(part(wi, "bed"))
    show_panel(part(wi, "slider"))
end procedure -- show_vscroll
m1 = routine_id("show_vscroll")

procedure on_rat_slide()
    sequence s1,s2
    integer h1,h2,t1,t2,nt,wm,w1

    wait_while(lbp)
    wm = main(self)             -- vscroll
    w1 = part(wm, "slider")     -- slider
    s1 = item(w1, "box")
    s2 = item(self, "box")      -- slide (bed)
    h1 = s1[4]
    h2 = s2[4]
    t1 = s1[2]
    t2 = s2[2]
    nt = ry-floor(h1/2)      -- new top of slider
    if nt<t2 then
        nt = t2
    elsif nt > t2+h2-h1 then
        nt = t2+h2-h1
    end if
    if nt != t1 then
        s1[2] = nt
        bind(w1, "box", s1)
        show_pane(self)
        show_panel(w1)
    end if
end procedure -- on_rat_slide
m2 = routine_id("on_rat_slide")
