--  window.e
--  jbabor@paradise.net.nz
--  00-11-22
--  widgets version 2.50

include pane.e
include pbutton.e

constant
    hidden = 0,
    idle = 1,
    busy = 2,
    tbh = 15,           -- default title bar height
    bigx = {            -- closing gadget image
        {4,1,1,1,1,1,4},
        {4,4,1,1,1,4,4},
        {1,4,4,1,4,4,1},
        {1,1,4,4,4,1,1},
        {1,1,4,4,4,1,1},
        {1,4,4,1,4,4,1},
        {4,4,1,1,1,4,4},
        {4,1,1,1,1,1,4}}

integer m1,m2,m3,m4,m5

procedure xor_box(integer c, integer x, integer y, integer w, integer h)
    sequence s
    integer x2,y2

    x2 = x+w-1
    y2 = y+h-1
    s = repeat(c, w)
    pixel(xor_bits(get_pixel({x,y,w}),s),{x,y})
    pixel(xor_bits(get_pixel({x,y2,w}),s),{x,y2})
    for i=y+1 to y2-1 do
        pixel(xor_bits(get_pixel({x,i}),c),{x,i})
        pixel(xor_bits(get_pixel({x2,i}),c),{x2,i})
    end for
end procedure -- xor_box

procedure show_tbar(integer wi)
    integer wm

    wm = main(wi)                   -- window
    if item(wm, "state") = busy then
        bind(wi, "color", 1)        -- dark blue
    else
        bind(wi, "color", 3)        -- dark gray (idle)
    end if
    show_pane(wi)
    show_text(part(wi, "title"))
end procedure -- show_tbar
m2 = routine_id("show_tbar")

procedure drag()                    -- drag window
    sequence im1,im2,s
    integer dx,dy,h,w,wm,xr,x0,x1,x,yr,y0,y1,y

    xr = rx   yr = ry               -- save rat position
    x = xr  y = yr                  -- 'previous' rat position
    wm = main(self)                 -- window
    s = item(wm, "box")
    x0 = s[1]
    x1 = x0
    y0 = s[2]
    y1 = y0
    w = s[3]
    h = s[4]
    hide_rat()
    rat_pointer(RAT_RESIZE)
    im1 = save_image({x0,y0},{x0+w-1,y0+h-1}) -- window image
    im2 = item(wm, "image")         -- previously saved background
    xor_box(15,x1,y1,w,h)
    show_rat()
    rat()
    while and_bits(rat_event, lbp) do
        if rx != x or ry != y then
            hide_rat()
            xor_box(15,x1,y1,w,h)    -- erase
            x1 += rx-x
            if x1<0 then x1 = 0
            elsif x1+w>hsize-1 then x1 = hsize-w
            end if
            y1 += ry-y
            if y1<0 then y1 = 0
            elsif y1+h>vsize-1 then y1 = vsize-h
            end if
            xor_box(15,x1,y1,w,h)   -- redisplay in 'new' location
            show_rat()
            x = rx
            y = ry
        end if
        rat()
    end while
    hide_rat()
    xor_box(15,x1,y1,w,h)           -- erase
    display_image({x0, y0}, im2)    -- re-display background
    dx = x1-x0
    dy = y1-y0
    shift(wm,dx,dy)
    s = item(wm, "box")
    bind(wm, "image", save_image(s[1..2],{s[1]+s[3]-1,s[2]+s[4]-1}))
    display_image(s[1..2], im1)     -- re-display window
    rat_pointer(RAT_ARROW)
    show_rat()
    track({wm})
end procedure -- drag
m5 = routine_id("drag")

global function window(
    sequence title,     -- text string
    integer x,          -- left edge
    integer y,          -- top edge
    integer w,          -- width
    integer h           -- height
    )
    integer wi,w1,w2,wt

    wi = panel(7,edge[1],x,y,w,h)
    bind(wi, "show", m3)
    make(wi, "hide", m4)
    make(wi, "state", hidden)
    make(wi, "image", {})

    w1 = pane(BLUE,x+3,y+3,w-21,tbh)
    bind(w1, "show", m2)
    make(w1, "event", lbp)
    make(w1, "rat", {m5})           -- drag
    affix(wi, "tbar", w1)

    wt = text(x+8, y+3+floor((tbh+1)/2), title)
    bind(wt, "fc", BRIGHT_WHITE)
    bind(wt, "attrib", NONE)
    bind(wt, "just", LEFT+BOXED)
    affix(w1, "title", wt)

    w2 = pbutton(x+w-16,y+3,13,15,bigx,3,3,1)
    bind(w2, "key", {esc})
    splice(w2, m1)                  -- hide window
    affix(wi, "closer", w2)

    return wi
end function -- window

global procedure show_window(integer wi)
    object o
    integer len, w1

    bind(wi, "state", busy)
    pile = append(pile, wi)         -- place window on top of pile
    len = length(pile)-1
    if len then
        w1 = pile[len]              -- window just under
        bind(w1, "state", idle)
        show(part(w1, "tbar"))
    end if

    -- save area under window
    o = item(wi, "box")
    hide_rat()
    bind(wi, "image", save_image(o[1..2],{o[1]+o[3]-1,o[3]+o[4]-1}))

    show_panel(wi)
    show(part(wi, "tbar"))
    show(part(wi, "closer"))
    pilef = true                    -- tell event handler about new window
end procedure -- show_window
m3 = routine_id("show_window")

global procedure hide_window(integer wi)
    -- close window and restore image under it

    object o, image
    integer len, w1

    o = item(wi, "box")
    image = item(wi, "image")
    hide_rat()
    display_image(o[1..2], image)
    show_rat()
    bind(wi, "state", hidden)
    bind(wi, "image", {})   -- be a good boy, save some memory!
    len = length(pile) - 1
    pile = pile[1..len]
    if len then
        w1 = pile[len]              -- menu or window just under
        bind(w1, "state", busy)
        show_tbar(part(w1, "tbar"))
        show_pbutton(part(w1, "closer"))
    end if
    pilef = true                    -- pile changed: exit inner event loop
end procedure -- hide_window
m4 = routine_id("hide_window")

procedure on_closer()
    hide_window(main(self))
end procedure -- on_closer
m1 = routine_id("on_closer")
